//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   10 Sep 08  Brian Frank  Creation
//
package fan.fwt;

import fan.sys.*;
import fan.sys.List;
import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Widget;

public class MonitorPeer
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public static MonitorPeer make(fan.fwt.Monitor self)
  {
    return new MonitorPeer();
  }

  static fan.fwt.Monitor make(Monitor swt)
  {
    fan.fwt.Monitor self = fan.fwt.Monitor.make();
    self.peer.swt = swt;
    return self;
  }

//////////////////////////////////////////////////////////////////////////
// Native methods
//////////////////////////////////////////////////////////////////////////

  public static List list()
  {
    return Env.get().monitors();
  }

  public static fan.fwt.Monitor primary()
  {
    return Env.get().primaryMonitor();
  }

  public Rect bounds(fan.fwt.Monitor self)
  {
    return WidgetPeer.rect(swt.getClientArea());
  }

  public Rect screenBounds(fan.fwt.Monitor self)
  {
    return WidgetPeer.rect(swt.getBounds());
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  Monitor swt;

}
